/****************************************************************************
**
** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the examples of the Qt Mobility Components.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Nokia Corporation and its Subsidiary(-ies) nor
**     the names of its contributors may be used to endorse or promote
**     products derived from this software without specific prior written
**     permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef COMPASSVIEW_H
#define COMPASSVIEW_H

#include <QCompass>
#include <QtGui>

QTM_USE_NAMESPACE

class QPainter;
class QWidget;
class QStringList;
class QPoint;
class QRadialGradient;
class CompassFilter;
class QFont;

//![0]
class CompassView : public QWidget
{
    Q_OBJECT

public:
    CompassView(QWidget *parent = 0);
    ~CompassView();

    void setAzimuth(qreal azimuth) {
        if (this->azimuth == azimuth)
            return;

        this->azimuth = azimuth;
        update();
    }

protected:
    void paintEvent(QPaintEvent *event);
    void resizeEvent(QResizeEvent *);

private:
    QCompass *compass;
    CompassFilter *filter;

     qreal azimuth;
//![0]
    QStringList chars;
    int charWidths[4];
    QPoint compassPointer[3];
    QPoint center;
    QColor lightSand;
    QColor darkSand;
    QColor darkWood;
    QColor lightWood;
    QRadialGradient gradient;
    QFont font;

    int totalWidth;
    int dialWidth;
    int textWidth;
//![1]
    bool compassAvailable;
};
//![1]

#endif // COMPASSVIEW_H
